# Ansible roles for setting up CI/CD environment

This subdirectory contains the roles that are needed to set up the CI/CD environment for automated benchmarking using GitLab CI. Before using the roles, we need to make sure that `config.yml` is correctly configured with all necessary variables. During the play, `ansible-vault` will encrypt this file and decrypt only when needed.

## Usage

Typically, we run the playbook from a control node. We should make sure that ssh connection from control node to all provisioned nodes is possible without a password. In the case of Grid5000, `kadeploy3` will take care of it when we use `-k` option.

The following workflow is for Grid5000 nodes and it can adopted to any platform easily. First, reserve the nodes in `deploy` mode. In this example, we use [nancy](https://www.grid5000.fr/w/Nancy:Hardware) site frontend and [grvingt](https://www.grid5000.fr/w/Nancy:Hardware#grvingt) cluster

```
user@fnancy: oarsub -I -l {"cluster='grvingt'"}/host=2,walltime=3 -t deploy -t destructive -p production
```
More details on `osrsub` options can be found in [documentation](https://www.grid5000.fr/w/Advanced_Kadeploy).

Once the nodes are reserved, we can provision them with a base OS, CentOS 8 in present case.

```
user@fnancy: kadeploy3 -f $OAR_NODEFILE -e centos8-x64-min -p TMP -k
```
It is important to use `-k` flag as it will copy the ssh public key on frontend to all nodes in the reservation which enables the passwordless ssh between frontend and reserved nodes. This is essential for ansible.


Now we can simply create a conda environment and install dependencies

```
user@fnancy: cd ska-sdp-benchmark-tests/.ci/hpc_ci/ansible
user@fnancy: conda create -n ansible python=3.8
user@fnancy: conda activate ansible
(ansible)user@fnancy: pip install -r requirements.txt
(ansible)user@fnancy: ansible-galaxy install -r requirements.yml
```

Now we need to modify the hostfile based on the node IP addresses of the reserved nodes. For instance, if `grvingt-0.nancy.grid5000.fr` and `grvingt-1.nancy.grid5000.fr` are reserved, the hostfile would be following

```
[compute]
grvingt-1.nancy.grid5000.fr

[manager]
grvingt-0.nancy.grid5000.fr

[nfs]
grvingt-0.nancy.grid5000.fr
```

Typically, we use first node in the reservation as manager/nfs node and rest of them as compute nodes.

Once the hostfile is setup, we can start the play using

```
(ansible)user@fnancy: ansible-playbook playbook.yml --user root -i hostfile --skip-tags "kubernetes"
```

Here we are skipping tasks related to Kubernetes and install only SLURM and related packages. By default ansible tries to ssh into nodes as same user as the control node. However, on Grid5000 the newly provisioned nodes do not have user created in them and hence, we need to login as `root`. Moreover we need to be `root` within the reserved nodes to install necessary softwares.

If the user wants to edit the `config.yml` file after it has been encrypted, we can do it as follows

```
(ansible)user@fnancy: ansible-vault edit config.yml --vault-password-file <password_file>
```

where `password_file` will be generated by ansible once the encryption is done.
